// Constanten für MK Smarthome with CAN BUs
// CAN_MK.h
// last Modiefied 07.02.2020

#ifndef CAN_MK_H
#define CAN_MK_H

// CAN CS
const uint8_t SPI_CS_PIN = 8;
// const uint8_t DHTPIN = 3;
// #define DHTTYE DHT22;
// EEPROM	stores Node Config
// FF not Configured
// Offsets
const uint8_t nodeID = 0;												// 0 Node Address
const uint8_t nodeGR = 1;												// 1 Node Group
		// noch nicht klar wie gruppen adressiert werden
		const uint8_t noGroup = 0xFF;	// is in no group
// Input devices, pushbuttons, switches etc.
// if target 0x00, target is always group
// ======== PushButtons / Switches ==============
// switches
const uint8_t inputBase = 2;										// 2 offset to keys
const uint8_t inputSkipPorts = 3; 							// skip ports
const uint8_t inputLen = 27;										// element length
const uint8_t inputNum = 4;											// max buttons
const uint8_t inputInnerLen = 6;								// inner len
const uint16_t inputMax = inputNum * inputLen;	// end
const uint8_t inputType = 0;										// offset button type
	// button types
		const uint8_t pushButton = 1;								// normal Pushbutton, default open
		const uint8_t revPushButton = 2;						// normal Pushbutton, default closed
		const uint8_t nSwitch	= 4;									// normal 2 oin switch, default open
		const uint8_t uSwitch = 8;									// normal 3 Pin switch, default open/closed
		const uint8_t eSwitch = 16;									// 3 Pin toggle switch, defaut open, up/down closed one or other
		const uint8_t pToggleSwitch = 32;						// 3 Pin toggle switch, default open, uo/down closed as long 	pressed
	const uint8_t inputPort_1 = 1;								// offset arduino port 1 the button is connected
	// port is define with oneButton
		const uint8_t button_1 = 0;     						// DO/RX
		const uint8_t button_2 = 1;     						// D1/TX
		const uint8_t button_3 = 7;     						// D7
		const uint8_t button_4 = 4;     						// D4
	const uint8_t inputPort_2 = 2;								// offset port 2, for switches with three pins for future use
		const uint8_t maxClick = 4;									// count ClickTypes
		const uint8_t nClick = 0;										// normal click
		const uint8_t dClick = 1;										// double click
//		const uint8_t slClick = 2;								// long press start !! not used now
		const uint8_t elClick = 2;									// while pressed
		const uint8_t wlClick = 3;									// long press stop
	const uint8_t inputTargetID = 1;							// offset past inputClick ID
	const uint8_t inputTargetGr = 2;							// offset send click target group
	const uint8_t inputTargetPort = 3;						// offset output port on target
	const uint8_t inputTargetFunc = 4;						// offset output function on target
	const uint8_t inputSourceGr = 5;						// offset source group
// function types
		const uint8_t t_OFF = 0;								// switch target OFF
		const uint8_t t_ON = 1;									// switch target ON
		const uint8_t t_Toggle = 2;								// reverse state on target
		const uint8_t t_Timed = 3;								// switch target ON for same time inputTargetGr has time in seconds
// feedback types
	const uint8_t noFeedBackreq = 0;			// no feedback request
	const uint8_t feedBackReq = 1;				// feddbach request
	const uint8_t grFeedBackReq = 2;			// group feedback request
// ====== LEDs =============
// LED array typ,port_1, dimm_1, port 2, dimm_2, port 3, dimm_3
const uint16_t ledBase = inputBase + inputMax;			// offset in EEPROM
	const uint8_t ledNum = 4;							// max LEDs to configure
	const uint8_t ledLen = 7;							// len one LED
	const uint8_t ledMax = ledNum * ledLen;
const uint8_t ledType = 0;								// 94 offset LED type
// LED type
		const uint8_t oneColor = 1;						// One color LED
		const uint8_t twoColor = 2;						// Two color LED
		const uint8_t threeColor = 4; 					// Three color LED for future use
const uint8_t ledPort_1 = 1;							// offset port LED grün
const uint8_t LedDim_1 = 2;
const uint8_t ledPort_2 = 3;							// offset port LED rot
const uint8_t LedDim_2 = 4;
const uint8_t ledPort_3 = 5;							// offset port LED gelb for future use
const uint8_t LedDim_3 = 6;
const uint8_t LED_1 = 0;								// erste LED
const uint8_t LED_2 = 1;								// zweite LED
const uint8_t LED_3 = 2;								// dritte LED
const uint8_t LED_4 = 3;								// vierte LED
const uint8_t gnLED = 0;								// grün
const uint8_t rdLED = 1;								// rote
const uint8_t yeLED = 2;								// gelbe
/*
		const uint8_t lPort1gn = 5;						// D5 PWM posible
		const uint8_t lPort2gn = 6;						// D6 PWM posible
		const uint8_t lPort3gn = 9;						// D9 PWM posible
		const uint8_t lPort4gn = 10;					// D10 PWM posible
		const uint8_t lPort1rt = 14;					// A0
		const uint8_t lPort2rt = 15;					// A2
		const uint8_t lPort3rt = 16;					// A3
		const uint8_t lPort4rt = 17;					// A4
		const uint8_t lPort1ge = 0xFF;					// n/a
		const uint8_t lPort2ge = 0xFF;					// n/a
		const uint8_t lPort3ge = 0xFF;					// n/a
		const uint8_t lPort4ge = 0xFF;					// n/a
*/
// ================ DISPLAYs ==============
// Display byte 138 - 141 
const uint16_t displayBase = ledBase + ledMax;				// offset in EEPROM
const uint8_t displayMax = 4;
const uint8_t displayType = 0;								// offset display type
		const uint8_t displayLCD = 1;						// type is LCD ADR 0x27
		const uint8_t displayGR = 2;						// type is graphic
		const uint8_t displayTouch = 4;						// type is graphic touchscreen
const uint8_t displayCols = 1;								// offset to cols, pixel horitontal if graphic
const uint8_t displayRows = 2;								// offset to rows, pixel vertical if graphic
const uint8_t displayAddr = 3;								// offset address

// ============= PIEPSER =================
// Piepser byte 142 - 143
const uint16_t piepsBase = displayBase + displayMax;
const uint8_t piepsMax = 2;									// offset in EEPROM
const uint8_t piepsType = 0;								// offset peep type
		const uint8_t piepsPassiv = 1;						// passiv peep
		const uint8_t piepsActiv = 2;						// activ peep
const uint8_t piepsPort = 1;								// offset to port
// =========== SENSORs ==========
// sensor byte 144 - 146
// sensor data pin is fx D3, D3 use by RTC too
const uint16_t sensorBase = piepsBase + piepsMax;
const uint8_t sensorMax = 3;							// offset in EEPROM
const uint8_t sensorTempType = 0;							// offset temperatur sensor
		const uint8_t sensorDHT = 1;						// DHT22
		const uint8_t sensorDS18B20 = 2;					// DS18B20
		const uint8_t sensorBME280 = 4;						// BME280
const uint8_t sensorHumitType = 1;							// offset humitity sensor
		const uint8_t sensorDHThum = 1;						// DHT22
		const uint8_t sensorBME280hum = 4;					// BME280
const uint8_t sensorPressureType = 2;						// offset pressure sensor
		const uint8_t sensorBME280pres = 4;					// BME280
// ================ OTHER ==============
// other base byte 147 - 156
const uint16_t otherBase = sensorBase + sensorMax;			// other peripherals
const uint8_t otherMax = 10;
const uint8_t otherRTC = 0;									// offset RTC uses D3 SQW interupt every second
		const uint8_t otherDS3231 = 1;						// is DS3231 type ZS-042 Module
const uint8_t otherIR = 1;									// offset in array
		const uint8_t IRdiode = 1;							// IR diode use D3 for Data
const uint8_t otherPIR = 2;									// offset in array PIR use D3 for Data
		const uint8_t PIRpin = 3;
		const uint8_t normalPIR = 1;						// Normal PIR
const uint8_t PIR_ID = 3;									// 
const uint8_t PIR_Gr = 4;									//
const uint8_t PIR_port = 5;									//
const uint8_t otherExtendAdr1 = 6;							// I2C address of 1st portextender PCF8574
const uint8_t otherExtendAdr2 = 7;							// I2C address of 2nd portextender PCF8574
const uint8_t otherExtendAdr3 = 8;							// I2C address of 3rd portextender PCF8574
const uint8_t otherExtendAdr4 = 9;							// I2C address of 4th portextender PCF8574

// byte 157 - 188 group of extender port
const uint16_t grBase = otherBase + otherMax;				// offset 0 - 9 of preceding makes 10
// byte 189, 190 = 0x55, 0xAA actual length is calculated on startup
// ====================================

// More EEPROM Offsets		should be reworked
// Datasheet say EEPROM 1024 = 1kbyte size
/* think we do not use it
const uint16_t stateBase = 512;			// ofsett in EEPROM for stat information
		const uint8_t nodeLED = 0;			// start array for 4 LED 12 by long
		const uint8_t greenLED = 0;			// offset green 0x00 Off, 0xFF On, PWM between
		const uint8_t redLED = 1;		  	// offset red 0x00 Off, 0xFF On, PWM between
		const uint8_t yellowLED = 2;		// offset yellow 0x00=Off, 0xFF=On, PWM between
*/
//const uint16_t stateBase = 512;			// ofsett in EEPROM for stat information
const uint16_t expBase = 512;				// array 128 32 ports 4 byte for a port
											// 0x01=On 0x00=Off 0xFF undef
	// stores portState=+0,
	// sourceID=+1,
	// sourceKey=+2,
	// feedbackreq
	const uint8_t expBaseMult = 4;			// multiplyer
	const uint8_t expState = 0;					// offset state
	const uint8_t expSource = 1;				// offset source
	const uint8_t expKey = 2;						// offset key
	const uint8_t expFeedBack = 3;			// offset feedback for timed
//=====================================================
// CAN message
const uint8_t N_ID = 0;								// 1st byte sender nodeID
const uint8_t M_Dest = 1;							// 2nd byte message destination type
		const	uint8_t	D_BC = 0;							// destination type broadcast
		const	uint8_t D_Group = 1;					// destination type group
		const uint8_t D_Node = 2;						// destination type node
const uint8_t M_Dest_ID = 2;						// 3rd byte 0x00 if BC else destination nodeID  or groupID
const uint8_t M_Type = 3;								// 4th byte Message Type
		const uint8_t Request = 0;					// Request return some information to sender defined by data
				const uint8_t PortState = 0;		// M_Data helds request type, M_Data+1 port number
				const uint8_t PingRequest = 1;		// see if node alive
		const uint8_t Action = 1; 					// function types defined in EEPROM t_on, t_off, t_toggle, t_timed
		const uint8_t U_Action = 2;					// ?? do we need its ??? user Action ,User did something, pressed button i.e.
				const uint8_t P_Button = 1;			// Push Button pressed,following byte has data
				const uint8_t O_Switch = 2;			// On/Off Switch changed, following byte has data
				const uint8_t T_Switch = 3;			// On/Off/On Switch changed, following byte has data
				const uint8_t M_Switch = 4;			// Momentory On/Off/On Switch pressed, following byte has data
		const uint8_t L_Info = 3;						// we will send some bytes, M_Data will have length
																				// answer too [M_Data port], [M_Data + 1] state
		const uint8_t Ack =	5; 							// Ack for a sent packet
		const uint8_t Data = 6; 						// data
		const uint8_t SetTime = 7; 					// set time and Date of RTC
		const uint8_t Conf = 8; 						// is a config, M_Data has subtype
		const uint8_t Info = 9;							// subtype S_ C_ in M_Data
		const uint8_t PingReply = 11;				// alive
		const uint8_t Feedback = 12;
		const uint8_t GrFeedback = 13;
// config subtype
				const uint8_t ConfReset = 0xFF;		// reset node
				const uint8_t ConfRequest = 0xFE;	// send config to sourceID
				const uint8_t ConfNewID = 0xEF;		// new node ID
				const uint8_t ConfNewGr = 0xED;		// new group
				const uint8_t ConfNew = 0xEE;			// it is complte new config
				
const uint8_t M_Data = 0; //4;							// 5th byte data bytes start here, max four byte
// sensors type of data
	const uint8_t S_Temp = 0x10;				// Temperatur
	const uint8_t S_Pressure = 0x11;		// Air pressure
	const uint8_t S_Humidity = 0x12;		// Humidity
// time type information
	const uint8_t C_Time = 0x20;			// local Time
	const uint8_t C_G_Time = 0X21;		// World Time
	const uint8_t C_Sunraise = 0x22;	// Todays SunRaise
	const uint8_t C_Sunset = 0x23;		// Todaya SunSet

// Error Codes
const uint8_t E_TimeoutSend = 0;
#define Timeout_Send F("TIMEOUT SEND")
const uint8_t E_TimeoutReceive = 1;
#define Timeout_Receive F("TIMEOUT RECEIVE")

#endif

// Message formats
// 1. byte length
// 2. byte destination type BC GROUP NODE
// 3. byte destination ID
// 4. byte message type see above
// these byte are encoded in CAN ID an decoded by destination
// more information in data M_Data[0]  ... M_Data[7]
// m_types
// DATA 0 .. 7 data
// ACK no data
// INFO info_type (time, temp, etc.) value[0] ... value[n]
// FEEDBACK request_source_port state
// ACTION
//	M_Data 		target port
const uint8_t actPort = M_Data;					// offset my be group too
//	M_Data+1 	target_action (ON, OFF, etc.)
const uint8_t	actAct = M_Data + 1;			// offset
//  M_Data+2	feedback (Y/N)
const uint8_t actFeedBack = M_Data + 2;	//  offset
//  M_Data+3	key
const uint8_t actKey = M_Data + 3;
// 	M_Data+4  timed time (option)
const uint8_t actTime = M_Data + 4;			// offset
// L_INFO
//	size of config